/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */


#ifndef __KYLIN_AI_IMAGE_RESULT_H__
#define __KYLIN_AI_IMAGE_RESULT_H__

#include <stdint.h>

#include "imageconfig.h"
#include "imageformat.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _VisionImageResult VisionImageResult;

ImageFormat image_result_get_format(VisionImageResult *image_result);
ImageSize image_result_get_size(VisionImageResult *image_result);
int image_result_get_total(VisionImageResult *image_result);
int image_result_get_index(VisionImageResult *image_result);
const uint8_t *image_result_get_data(VisionImageResult *image_result,
                                     int *data_length);
int image_result_get_error_code(VisionImageResult *image_result);
const char *image_result_get_error_message(VisionImageResult *image_result);

typedef void (*VisionImageResultCallback)(VisionImageResult *result,
                                          void *user_data);

#ifdef __cplusplus
}
#endif

#endif
